import scriptHandler, globalPluginHandler, ui, api, braille, textInfos, speech, controlTypes, characterProcessing
import os, sys
#path = os.path.dirname(__file__)
#sys.path.append(path)

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
  @scriptHandler.script(description = "播報瀏覽游標所在字元，快按兩次播報字元解釋，快按三次播報字元內碼，快按四次查閱字典，快暗午次查閱辭典",
    category = "Text review",
    gestures = ("kb:numpad2", "kb(laptop):NVDA+."))
  def script_pad2(self, gesture):
    info=api.getReviewPosition().copy()
    info.expand(textInfos.UNIT_CHARACTER)
    braille.handler.setTether(braille.handler.TETHER_REVIEW, auto = True)
    scriptCount = scriptHandler.getLastScriptRepeatCount()
    if scriptCount == 0:
      speech.speakTextInfo(info, unit = textInfos.UNIT_CHARACTER, reason = controlTypes.OutputReason.CARET)
    if scriptCount == 1:
      speech.spellTextInfo(info, useCharacterDescriptions = True)
      char = info.text.lower()
      desc = characterProcessing.getCharacterDescription("zh_TW", char)
      braille.BrailleHandler.message(braille.handler, char+" "+" ".join(desc))
    if scriptCount == 2:
      try:
        c = ord(info.text)
      except TypeError:
        c = None
      if c is not None:
        speech.speakMessage("%d," % c)
        speech.speakSpelling(hex(c))
        char = info.text.lower()
        braille.BrailleHandler.message(braille.handler, f"{char} {c} {hex(c)}")
      else:
        log.debugWarning("Couldn't calculate ordinal for character %r" % info.text)
        speech.speakTextInfo(info, unit = textInfos.UNIT_CHARACTER, reason = controlTypes.OutputReason.CARET)
